Permutations - Leetcode 46 - Python

Ғылым және технология

🚀 neetcode.io/ - A better way to prepare for Coding Interviews
🧑‍💼 LinkedIn: / navdeep-singh-3aaa14161
🐦 Twitter: / neetcode1
⭐ BLIND-75 PLAYLIST: • Two Sum - Leetcode 1 -...
Problem Link: neetcode.io/problems/permutat...
0:00 - Read the problem
0:30 - Drawing Explanation
6:08 - Coding Recursive
9:35 - Coding Iterative
leetcode 46
#neetcode #leetcode #python

Пікірлер: 17

  • @hasferrr
    @hasferrr11 күн бұрын

    i think the backtracking solution with decision tree is more intuitive. For each recursion call, you can store the number that has already added to the Answer list into the HashSet, and for each recursion call you can skip the number that already in the HashSet function permute(nums: number[]): number[][] { const result = [] const dfs = (set: Set, pm: number[]): void => { if (pm.length === nums.length) { result.push([...pm]) return } for (let i = 0; i if (set.has(nums[i])) { continue } pm.push(nums[i]) set.add(nums[i]) dfs(set, pm) pm.pop() set.delete(nums[i]) } } dfs(new Set(), []) return result }

  • @riddle-master-ruben
    @riddle-master-ruben25 күн бұрын

    This is a way better explanation than the old video. I went months with this problem unsolved because I just couldn't understand, but this explanation helped me tremendously. Thanks!

  • @bandarupawankumar7549
    @bandarupawankumar754925 күн бұрын

    Thank you neetcode for again working on this problem :)

  • @MyPodie
    @MyPodie26 күн бұрын

    Morning Neetcode!

  • @pastori2672
    @pastori267225 күн бұрын

    i feel like a time traveler

  • @AVGVSTVSivlivs
    @AVGVSTVSivlivs22 күн бұрын

    Swapping indices method for this question is probably more clear and you should also review Longest Palindromic Substring question. Solutions in the other questions are quite optimal. Thanks a lot!

  • @johnveracruz2102
    @johnveracruz210225 күн бұрын

    @NeetcodeIO PLS add a functionality on your site to not show the topics for the questions. want to do them in order without knowing the topic. thanks

  • @user-vu4ng4rb8k
    @user-vu4ng4rb8k26 күн бұрын

    hey also do video for cherry pickup 1 and bst to sorted DLL

  • @kanjurer
    @kanjurer25 күн бұрын

    I actually just solved the problem yesterday lmao

  • @ijavd
    @ijavd26 күн бұрын

    Morning

  • @Gomeroff
    @Gomeroff26 күн бұрын

    I live in Russia, a new day has not yet begun, and you are already solving a new problem)

  • @mukeshrawat1304
    @mukeshrawat130425 күн бұрын

    Is it possible for you to have some sort of poll or something where we could ask for a video solution of a leetcode problem which you haven't already solved. Because there are quite a few problems which don't have a proper solution on KZread and God knows when they will appear as POTD.

  • @DeathSugar

    @DeathSugar

    25 күн бұрын

    I guess thats what his site is for.

  • @pushkarsaini2
    @pushkarsaini225 күн бұрын

    Now Solve 31 Next Permutation

  • @m_jdm357
    @m_jdm35712 күн бұрын

    The worst solution I've seen.

  • @NeetCodeIO

    @NeetCodeIO

    12 күн бұрын

    anything specific about it that you did not like?

  • @m_jdm357

    @m_jdm357

    12 күн бұрын

    @@NeetCodeIO I tried to understand it but it's really bad when debugging or writing down on paper. Really hard to understand. I found this solution: def permute(self, nums: List[int]) -> List[List[int]]: res = [] def backtrack(arr): if len(arr) == len(nums): res.append(arr.copy()) return for i in range(len(nums)): if nums[i] in arr: continue arr.append(nums[i]) backtrack(arr) arr.pop() backtrack([]) return res This I got. If no one supports me and everyone thinks your solution is good. Then I'm wrong.

Келесі